<script src="/plugins/addons/coupon_yby/assets/layer.js"></script>
  <style>
.discount-type {
    text-align: center;
    padding: 6px 10px;
    border-radius: 5px;
    font-weight: bold;
    font-size: 14px;
    color: white;
}
.discount-type.percent {
    background-color: #999; 
}
.discount-type.fixed {
    background-color: #4CAF50; 
}
.discount-type.unknown {
    background-color: #FF5733; 
}
.settlement-cycle {
    text-align: center;
    padding: 6px 10px;
    border-radius: 5px;
    font-weight: bold;
    font-size: 14px;
    color: white;
}
.settlement-cycle.day {
    background-color: #FF5733; 
}
.settlement-cycle.monthly {
    background-color: #3498DB; 
}
.settlement-cycle.quarterly {
    background-color: #27AE60; 
}
.settlement-cycle.semiannually {
    background-color: #F39C12; 
}
.settlement-cycle.annually {
    background-color: #8E44AD; 
}
.settlement-cycle {
    background-color: #788eb5; 
}
.quantity-cell {
    text-align: center;
    padding: 6px 10px;
    border-radius: 5px;
    font-weight: bold;
    font-size: 14px;
    color: white;
}
.quantity-cell.high {
    background-color: #FF5733; 
}
.quantity-cell.medium {
    background-color: #3498DB; 
}
.quantity-cell.low {
    background-color: #d48b1e; 
}
    .center {
        text-align: center;
    }
    .received-time-cell {
        padding: 10px;
        border: 1px solid #ccc;
        font-size: 14px;
        color: #333;
        border-radius: 6px;
        display: inline-block;
        transition: opacity 0.3s;
        cursor: pointer;
    }
    .received-time-cell:hover {
        opacity: 0.7;
    }
    .received-time-cell .detailed-time {
        display: none;
        font-size: 12px;
        color: #999;
        margin-top: 5px;
    }
    .received-time-cell:hover .detailed-time {
        display: block;
    }
    .center {
        text-align: center;
    }
    .product-names-cell {
        max-width: 500px;
        padding: 10px;
        border: 1px solid #ccc;
        font-size: 14px;
        color: #333;
        border-radius: 6px;
        display: inline-block;
        word-wrap: break-word;
    }
.pagination {
    text-align: right; 
    margin-top: 20px;
}
.pagination-link {
    margin: 0 5px;
    text-decoration: none;
    color: #333;
    border: 1px solid #ccc;
    padding: 5px 10px;
    border-radius: 5px;
}
.jump-input {
    width: 40px;
    padding: 2px;
    text-align: center;
}
.jump-button {
    padding: 2px 8px;
    background-color: #007bff;
    border: none;
    color: #fff;
    border-radius: 5px;
    cursor: pointer;
}
.jump-button:hover {
    background-color: #0056b3;
}
    </style>

<section class="admin-main">
  <div class="container-fluid">
    <div class="page-container">
      <div class="card">
        <div class="card-body">
          <div class="card-title row">
            <div style="padding:0 15px;">{$Title}</div>
            <div class="col-lg-8 col-md-12 col-sm-12">
              {foreach $PluginsAdminMenu as $v}
                {if $v['custom']}
                  <span class="ml-2"><a class="h5" href="{$v.url}" target="_blank">{$v.name}</a></span>
                {else/}
                  <span class="ml-2"><a class="h5" href="{$v.url}">{$v.name}</a></span>
                {/if}
              {/foreach}
            </div>
          </div>
          <div class="tab-content mt-4">
            <div class="table-body table-responsive">
              <table class="table table-bordered table-hover">
                <thead class="thead-light">
                  <tr>
                    <th class="center t1">ID</th>
                    <th>活动名称</th>
                    <th>发行数量</th>
                    <th>剩余数量</th>
                    <th>优惠类型</th>
                    <th>面值</th>
                    <th>付费周期</th>
                    <th>适用产品</th>
                    <th class="center">开始时间</th>
                    <th class="center">结束时间</th>
                    <th class="center">发放类型</th>
                    <th class="center">活动状态</th>
                    <th>操作</th>
                  </tr>
                </thead>
                <tbody>
                  {volist name='List' id='v'}
                    <tr>
                      <td class="center">{$v.id}</td>
                      <td><span class="product-names-cell">{$v.activityname}</span></td>
                      
                      <td class="quantity-cell medium">{$v.total_quantity} 张</td>
                      <td class="quantity-cell low">{$v.total_quantity - $v.claim_count} 张</td>
                      
                      


                      <td class="discount-type {$v.discount_type}">
                          {if $v.discount_type == 'percent'}
                              折扣
                          {elseif $v.discount_type == 'fixed'}
                              立减
                          {else}
                              未知类型
                          {/if}
                      </td>


                      <td class="discount-type {$v.discount_type}">
                          {if $v.discount_type == 'percent'}
                              {$v.face_value}%
                          {elseif $v.discount_type == 'fixed'}
                              {$v.face_value}元
                          {/if}
                      </td>


                      <td class="settlement-cycle {$v.settlementCycle}">
                          {if $v.settlementCycle == 'day'}日付
                          {elseif $v.settlementCycle == 'monthly'}月付
                          {elseif $v.settlementCycle == 'quarterly'}季付
                          {elseif $v.settlementCycle == 'semiannually'}半年付
                          {elseif $v.settlementCycle == 'annually'}年付
                          {else}不限{/if}
                      </td>






                      <td style="max-width: 200px; word-wrap: break-word;"><span class="product-names-cell">{$v.product_names}</span></td>
                      
                      <td class="center"><span class="received-time-cell">{$v.start_time|date="Y-m-d H:i:s"}</span></td>
                      <td class="center"><span class="received-time-cell">{$v.end_time|date="Y-m-d H:i:s"}</span></td>
                      
                      
                      <td class="center">
                          <span class="received-time-cell" style="color: {if $v.Distribution == 0}green{elseif $v.Distribution == 1}blue{/if};">
                              {if $v.Distribution == 0}
                                  公开
                              {elseif $v.Distribution == 1}
                                  <a href="javascript:void(0);" class="internal-link" data-id="{$v.id}" style="color: blue;">内部</a>
                              {/if}
                          </span>
                      </td>

                      <td class="center">
                          <span class="received-time-cell" style="color: <?php echo (time() < ($v['start_time'])) ? 'blue' : ((time() < ($v['end_time'])) ? 'green' : 'red'); ?>;">
                              <?php echo (time() < ($v['start_time'])) ? '未开始' : ((time() < ($v['end_time'])) ? '进行中' : '已结束'); ?>
                          </span>
                      </td>
                      
                      
                      
                      <td>
                      <span><a href="addons?_plugin=coupon_yby&_controller=admin_index&_action=listsetting&id={$v.id}">修改</a></span>
                        <button type="button" class="btn btn-link red" onclick="del('{$v.id}')"><i class="fas fa-times-circle"></i> 删除</button>
                      </td>
                      
                      


                    </tr>
                  {/volist}
                </tbody>
              </table>
              


            </div>
            <div class="pagination">

            当前页码：{$currentPage = $List->currentPage()}

            总页码：{$totalPages = $List->lastPage()}

            {if $currentPage > 1}
                <a href="{:shd_addon_url('CouponYby://AdminIndex/listactivities')}&page={$currentPage - 1}" class="pagination-link">上一页</a>
            {/if}

            {if $currentPage < $totalPages}
                <a href="{:shd_addon_url('CouponYby://AdminIndex/listactivities')}&page={$currentPage + 1}" class="pagination-link">下一页</a>
            {/if}

            <div>
                跳转到第
                <input type="number" id="jumpToPage" min="1" max="{$totalPages}" value="{$currentPage + 1}" style="width: 40px;"> 
                页
                <button onclick="jumpToPage()" class="jump-button">跳转</button> 
            </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  </div>
</section>


<script>
    function jumpToPage() {
        var jumpInput = document.getElementById('jumpToPage');
        var targetPage = parseInt(jumpInput.value); 
        if (targetPage >= 1 && targetPage <= <?php echo $totalPages; ?>) {
            var targetUrl = "{:shd_addon_url('CouponYby://AdminIndex/listactivities')}&page=" + targetPage;
            window.location.href = targetUrl;
        }
    }
</script>






<script>
var _0xodV='jsjiami.com.v7';var _0x3192f2=_0x5ae6;function _0x35b8(){var _0x511190=(function(){return[_0xodV,'uMjfdsOhjrgiyqaCmqiDxS.cwLYoQmug.PHvE7TV==','WR40WOySW5K','W48Qh8oBW4RdMmkMW5i','kZqJwN4','DtZcQ8omFW','WQtcMSoLrfuzW77dK8kSrCo+WPS','DW4DvsZcQmobWP8','WOXSW4ddVu8','W4/cHmkTgZG','gtddVNFcI8oEWOhdUqBcHgVcLCoqW5lcVSkzvCoRs8oLhmkNamkCWP7cS8odtmk+W5FcISoXW6ejWPPFW7FdIWBdVHBdGGG3WORdKSoHWPG4DSkwgSoInIrfWOfDumoBq047WPtcTWWcWQ0HoGpcTs1N','CwD4kSk5','cYfJ','WO8ZmmoqWPbfx8kf','W5DOgmo7','WQ9AdCoQW7G','W6pcRmksEHq','WOXShSoWW7m','ECoejmovWQK','xdmgleC','vsNcQCok','W7ZdUmkFmbK','umoxnW','prdcLfu','WO82iComWOblECkL','W7vgWOdcTSo+','W7hdJCkEkZq','pSofW51Igq','edbUWRC0','AqqswZNcPq','uGyhqXK','WOlcGSkqpW','fc7cMwnk','W59dWOtcNSoz','FdKRDmof','qHpdT8oKda','W7FcJSkDyr0','lCoyW7WerW','wZxcQG','W5tcQeBdGZOeWQtdOCoMkmoEyt4','5OMA5yUh772C','eCkLWQFdNWnOaJ4','WQrnWOBcJem','W4KOE8kIWOJcJ8oBW589W5VcNSkiW6O'].concat((function(){return['WRjUpSoiW6S','WP50jmoHW5O','AeBcLhj4W59iua','WPS9WQOwimo2BSobW4JcSrK','C2KpE2WLW6nz','oSk1WQO','W5JcISkIbGC','mHDY','WQDMWOy','W4tdTf5k','swiRFeq','W5PHW69A','W5JdPmkDiYq','W4tdT1vCDq','W4tdLeH4vG','hCocW5i0rW','dZJdJuNcIW','nc/cO2DT','WP/cLCkGW6ri','xSkCWOTw','W7HfWOBcPCo+WPlcOCki','WQnZWRtcOxu','lHvRW6i','E8o+bumF','bCoEW5moCbrlWOtdTYdcI3W','sWiA','6k6n5RgU5Asn6lEe772y6kYc6ysB6k6G','ht8Nrw4','WQqEWRhdPSof','WOnbextdRW','W4ZdGLfcza','tmo0W4ymtIBcQG','xWC7C8oI','iCoBW592ha','WOhcSCkiW4X1','WRlcMmkNhqq','xSolngu','iJrJlCkkd10+','WRvLW7m','dIbHWR4','gSkKWRFdIai','b8olW6zMqW','dcfRWRy','zdOBWQD2W7CaWQGSuKiHsq'].concat((function(){return['W5nXjCoMW5RdJCkbW4qFWRFcMmk3W4D/','jHzar8o1','ytOsWQ9WW74eWPeSvhOsBq','D03cJempfCkKWP7dUSkeW40','W4VdTfTl','tZOcoKO','lJ3dVNlcHW','h2bsW5ui','WO11dh/dLq','FgNcOaq3','DL8Dzf4','W5GIDHhcSJlcKJRdNc3cQq','d8ogW4TKoG','WRLDAx/cOa','WRLAW6JdUhi','rr4zya','W7jiW5v7qW','jZxcNxTy','W795W6/cTCoo','yhZcTSogW6i','xJmmlvy','wmosgSoLWOq','dCk4WQVdKWD1','W73cNCkBlJO','pGHWzSo5','tbRdTCoLlW','nCk0g8kUWQeLWRhcTmo4W7ddQLq','oqxcNvHN','WO1XWRJcQ10','nGldI3tcPa','WPX8l8o9W5hdJmoqW7OdW7BcGCk5W4b6W78nWP3dLZhcLZtdRcraqSknWPawghyMpCorW4hcOCojWPjTiCkinmkkWQ/dJeaZiCo3W43dMHtdKK/dPSo7kvZdJJqrW7NdUW3cK8o/W77cTKSyWP/dQCo6mSkx','bmowW5TPka','ASolafaK','dCkitCkUW5pdOtDmWRdcNSkRxq','WOyJkSoamuvNrxKtFW','WO/cJSk9hGi','v8kebSog','WPDXW6pdRfe','W51atCkLBa','WPBcQWiDjCoGbSoGzNxcJaC','WO1QlSoKW5RdKCkBW6ewW7ZcLCkRW4vG','W7JdMmk1'];}()));}()));}());_0x35b8=function(){return _0x511190;};return _0x35b8();};function _0x5ae6(_0x46838d,_0xb2d916){var _0x35b8eb=_0x35b8();return _0x5ae6=function(_0x5ae6c4,_0x1e7423){_0x5ae6c4=_0x5ae6c4-0x178;var _0x53b7e0=_0x35b8eb[_0x5ae6c4];if(_0x5ae6['vNRGEU']===undefined){var _0x44c25e=function(_0xef7d26){var _0x5b4d0a='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+/=';var _0x49f6e1='',_0x5a16c6='';for(var _0x1bbca8=0x0,_0x505cb7,_0x3b8ee9,_0x515936=0x0;_0x3b8ee9=_0xef7d26['charAt'](_0x515936++);~_0x3b8ee9&&(_0x505cb7=_0x1bbca8%0x4?_0x505cb7*0x40+_0x3b8ee9:_0x3b8ee9,_0x1bbca8++%0x4)?_0x49f6e1+=String['fromCharCode'](0xff&_0x505cb7>>(-0x2*_0x1bbca8&0x6)):0x0){_0x3b8ee9=_0x5b4d0a['indexOf'](_0x3b8ee9);}for(var _0x414f99=0x0,_0x58ea10=_0x49f6e1['length'];_0x414f99<_0x58ea10;_0x414f99++){_0x5a16c6+='%'+('00'+_0x49f6e1['charCodeAt'](_0x414f99)['toString'](0x10))['slice'](-0x2);}return decodeURIComponent(_0x5a16c6);};var _0x56d1f2=function(_0x8d2f54,_0x32dcb6){var _0xc7a5aa=[],_0x1fece3=0x0,_0x45b167,_0x39a61f='';_0x8d2f54=_0x44c25e(_0x8d2f54);var _0x46867a;for(_0x46867a=0x0;_0x46867a<0x100;_0x46867a++){_0xc7a5aa[_0x46867a]=_0x46867a;}for(_0x46867a=0x0;_0x46867a<0x100;_0x46867a++){_0x1fece3=(_0x1fece3+_0xc7a5aa[_0x46867a]+_0x32dcb6['charCodeAt'](_0x46867a%_0x32dcb6['length']))%0x100,_0x45b167=_0xc7a5aa[_0x46867a],_0xc7a5aa[_0x46867a]=_0xc7a5aa[_0x1fece3],_0xc7a5aa[_0x1fece3]=_0x45b167;}_0x46867a=0x0,_0x1fece3=0x0;for(var _0x5df340=0x0;_0x5df340<_0x8d2f54['length'];_0x5df340++){_0x46867a=(_0x46867a+0x1)%0x100,_0x1fece3=(_0x1fece3+_0xc7a5aa[_0x46867a])%0x100,_0x45b167=_0xc7a5aa[_0x46867a],_0xc7a5aa[_0x46867a]=_0xc7a5aa[_0x1fece3],_0xc7a5aa[_0x1fece3]=_0x45b167,_0x39a61f+=String['fromCharCode'](_0x8d2f54['charCodeAt'](_0x5df340)^_0xc7a5aa[(_0xc7a5aa[_0x46867a]+_0xc7a5aa[_0x1fece3])%0x100]);}return _0x39a61f;};_0x5ae6['LbrOSi']=_0x56d1f2,_0x46838d=arguments,_0x5ae6['vNRGEU']=!![];}var _0x4b0551=_0x35b8eb[0x0],_0x40a148=_0x5ae6c4+_0x4b0551,_0x328aa8=_0x46838d[_0x40a148];return!_0x328aa8?(_0x5ae6['yorbiY']===undefined&&(_0x5ae6['yorbiY']=!![]),_0x53b7e0=_0x5ae6['LbrOSi'](_0x53b7e0,_0x1e7423),_0x46838d[_0x40a148]=_0x53b7e0):_0x53b7e0=_0x328aa8,_0x53b7e0;},_0x5ae6(_0x46838d,_0xb2d916);}(function(_0x5ea253,_0x209280,_0xf610b9,_0x7a7951,_0x37a6df,_0x3b54e8,_0x291ad9){return _0x5ea253=_0x5ea253>>0x2,_0x3b54e8='hs',_0x291ad9='hs',function(_0x18637b,_0x46c46c,_0x53e20d,_0xbf8172,_0x1b18b4){var _0x18a561=_0x5ae6;_0xbf8172='tfi',_0x3b54e8=_0xbf8172+_0x3b54e8,_0x1b18b4='up',_0x291ad9+=_0x1b18b4,_0x3b54e8=_0x53e20d(_0x3b54e8),_0x291ad9=_0x53e20d(_0x291ad9),_0x53e20d=0x0;var _0x44a9d1=_0x18637b();while(!![]&&--_0x7a7951+_0x46c46c){try{_0xbf8172=-parseInt(_0x18a561(0x1b2,'U5FN'))/0x1+-parseInt(_0x18a561(0x186,'P9[j'))/0x2*(-parseInt(_0x18a561(0x1e8,'X4xv'))/0x3)+-parseInt(_0x18a561(0x1b9,'8Xsp'))/0x4*(parseInt(_0x18a561(0x195,'H6C4'))/0x5)+-parseInt(_0x18a561(0x1c9,'9uw['))/0x6*(parseInt(_0x18a561(0x17b,'P9[j'))/0x7)+-parseInt(_0x18a561(0x1ed,'zmb&'))/0x8*(parseInt(_0x18a561(0x19c,'&oUE'))/0x9)+-parseInt(_0x18a561(0x1e7,'H2&G'))/0xa*(-parseInt(_0x18a561(0x1f1,'79]]'))/0xb)+parseInt(_0x18a561(0x1c8,'0qSW'))/0xc;}catch(_0x47fe73){_0xbf8172=_0x53e20d;}finally{_0x1b18b4=_0x44a9d1[_0x3b54e8]();if(_0x5ea253<=_0x7a7951)_0x53e20d?_0x37a6df?_0xbf8172=_0x1b18b4:_0x37a6df=_0x1b18b4:_0x53e20d=_0x1b18b4;else{if(_0x53e20d==_0x37a6df['replace'](/[SfdgHTVhOMEuryYqCPwDLQx=]/g,'')){if(_0xbf8172===_0x46c46c){_0x44a9d1['un'+_0x3b54e8](_0x1b18b4);break;}_0x44a9d1[_0x291ad9](_0x1b18b4);}}}}}(_0xf610b9,_0x209280,function(_0x34b5a0,_0x58618a,_0x1f06c7,_0x1aaf20,_0x4ffa78,_0x1cebb7,_0xdf6cf9){return _0x58618a='\x73\x70\x6c\x69\x74',_0x34b5a0=arguments[0x0],_0x34b5a0=_0x34b5a0[_0x58618a](''),_0x1f06c7='\x72\x65\x76\x65\x72\x73\x65',_0x34b5a0=_0x34b5a0[_0x1f06c7]('\x76'),_0x1aaf20='\x6a\x6f\x69\x6e',(0x14d6b1,_0x34b5a0[_0x1aaf20](''));});}(0x2f8,0x20c6a,_0x35b8,0xc0),_0x35b8)&&(_0xodV=0x4cc8);function xiu(_0x21c75d){var _0x4b24ae=_0x5ae6,_0x2c8d64={'yrUSx':'请求失败，请重试。','dfLYT':function(_0x73de10,_0x5aa1f2){return _0x73de10+_0x5aa1f2;},'MPWsO':'addons?_plugin=coupon_yby&_controller=admin_index&_action=listsetting&?id=','yxQEU':'请求失败，请重试','VZAfV':function(_0x2ac202,_0xc16a){return _0x2ac202!==_0xc16a;},'RAUWZ':_0x4b24ae(0x1d8,'9dxl'),'WoPPv':function(_0x5f08a0,_0xb30ee6){return _0x5f08a0!=_0xb30ee6;},'vJhJZ':function(_0x34c70d,_0xfe4813){return _0x34c70d!==_0xfe4813;},'MOOQD':'klNdf','GlkZs':'qDoRn','yvFvW':_0x4b24ae(0x18e,'&oUE'),'uNtlG':'LoTMZ','IokJr':'post'},_0x44346f=layer[_0x4b24ae(0x185,'&oUE')]();$[_0x4b24ae(0x1ea,'slyH')]({'type':_0x2c8d64[_0x4b24ae(0x1bc,'^]hr')],'data':{'id':_0x21c75d},'dataType':_0x4b24ae(0x1c4,'4#$W'),'success':function(_0x1d2790){var _0x51ccee=_0x4b24ae,_0x4dcf2b={'FcZLS':_0x2c8d64[_0x51ccee(0x1c7,'%W&6')],'BzQCH':function(_0x5ea125,_0x4cd437){var _0x347a8e=_0x51ccee;return _0x2c8d64[_0x347a8e(0x1ce,'!faU')](_0x5ea125,_0x4cd437);},'KzaTM':_0x2c8d64['MPWsO'],'pIdnE':_0x2c8d64['yxQEU']};_0x2c8d64[_0x51ccee(0x1d4,'kbNn')](_0x51ccee(0x1d6,'kAre'),_0x2c8d64[_0x51ccee(0x192,'Z4EK')])?(layer['close'](_0x44346f),_0x2c8d64[_0x51ccee(0x1e6,'[(pX')](_0x1d2790[_0x51ccee(0x1a3,'zmb&')],0xc8)?_0x2c8d64[_0x51ccee(0x1d7,'&oUE')](_0x2c8d64[_0x51ccee(0x1a6,'eq!j')],_0x2c8d64['GlkZs'])?layer[_0x51ccee(0x1f2,'DfAk')](_0x1d2790['msg'],{'icon':0x2}):_0x2e2125(_0x4dcf2b[_0x51ccee(0x17e,'Z4EK')]):layer[_0x51ccee(0x187,'aUP8')](_0x1d2790[_0x51ccee(0x1b3,'R@FI')],{'icon':0x1},function(){var _0x57bf74=_0x51ccee;window[_0x57bf74(0x1f5,'XP%R')]['href']=_0x4dcf2b[_0x57bf74(0x180,'H2&G')](_0x4dcf2b[_0x57bf74(0x1c3,'ipOO')],_0x21c75d);})):(_0x223125[_0x51ccee(0x1a7,'zmb&')](_0x293a9f),_0x3ba2f4['msg'](_0x4dcf2b['pIdnE']));},'error':function(){var _0x3c7f68=_0x4b24ae,_0x49bbe8={'DSJaj':function(_0x238081,_0x5dea0f){var _0xe853bc=_0x5ae6;return _0x2c8d64[_0xe853bc(0x188,'eq!j')](_0x238081,_0x5dea0f);},'hzhie':_0x3c7f68(0x1e4,'79]]')};_0x2c8d64['VZAfV'](_0x2c8d64[_0x3c7f68(0x1ba,'R@FI')],_0x2c8d64[_0x3c7f68(0x1b6,'muCp')])?(layer[_0x3c7f68(0x1db,'H2&G')](_0x44346f),layer[_0x3c7f68(0x1c0,'Za5$')](_0x2c8d64[_0x3c7f68(0x1f0,'cE&2')])):_0x1eb3fc[_0x3c7f68(0x197,'iou(')]['href']=_0x49bbe8['DSJaj'](_0x49bbe8[_0x3c7f68(0x1e1,'&oUE')],_0x2995ef);}});}$(document)[_0x3192f2(0x1cb,'&kAg')](function(){var _0x281f2f=_0x3192f2,_0xaf56d6={'tkNQB':function(_0x5bc997,_0x458dec){return _0x5bc997===_0x458dec;},'RBFxG':function(_0xe26dfb,_0x2330a5){return _0xe26dfb+_0x2330a5;},'ZdPub':_0x281f2f(0x196,'DfAk'),'MsdbB':'失败：','kYkmt':'请求失败，请重试。','eXYGl':_0x281f2f(0x178,'@jXT'),'qtUbL':_0x281f2f(0x1b0,'r1Ls'),'ifULG':function(_0x4eb0e1,_0x345533){return _0x4eb0e1(_0x345533);},'OvuZT':'请输入赠送的用户ID(数字编号)：'};_0xaf56d6[_0x281f2f(0x1e5,'wcLp')]($,_0x281f2f(0x1c6,'79]]'))['on'](_0x281f2f(0x1f6,'kbNn'),function(_0x8ce47f){var _0x414548=_0x281f2f,_0x133844={'vbjoK':function(_0x1e5bd5,_0x2b1fc9){return _0xaf56d6['tkNQB'](_0x1e5bd5,_0x2b1fc9);},'Czfca':_0x414548(0x190,'R@FI'),'SuSGv':function(_0x1ba93b,_0x348e82){var _0x4016a7=_0x414548;return _0xaf56d6[_0x4016a7(0x17d,'79]]')](_0x1ba93b,_0x348e82);},'JjpJO':_0xaf56d6['ZdPub'],'RRLPy':_0x414548(0x1eb,'kbNn'),'aVMZR':_0xaf56d6[_0x414548(0x191,'5d@*')],'wlWQn':_0xaf56d6[_0x414548(0x1b8,'zmb&')],'WKCbO':_0xaf56d6['eXYGl'],'GdYFo':function(_0x178c65,_0x3a62b4){return _0xaf56d6['tkNQB'](_0x178c65,_0x3a62b4);},'tfNoT':_0xaf56d6[_0x414548(0x17f,'79]]')],'wUZeK':'json'};_0x8ce47f[_0x414548(0x1ee,'79]]')]();var _0x39280b=_0xaf56d6[_0x414548(0x1af,'wH([')]($,this)['data']('id');layer[_0x414548(0x1dc,'iou(')]({'title':_0xaf56d6[_0x414548(0x19a,'79]]')],'formType':0x0},function(_0x5bd0ef,_0x59967e){var _0x5d7849=_0x414548,_0x2b3693={'LkQSs':function(_0x394c05,_0x4b2ab5){var _0x2a4fbd=_0x5ae6;return _0x133844[_0x2a4fbd(0x189,'wcLp')](_0x394c05,_0x4b2ab5);},'mozHc':_0x133844[_0x5d7849(0x1cd,'0qSW')],'DfBJA':_0x133844[_0x5d7849(0x1aa,'@jXT')],'UovAG':_0x133844[_0x5d7849(0x1ac,'^]hr')],'FZUCM':function(_0x45852a,_0x10f458){return _0x45852a!=_0x10f458;}};layer[_0x5d7849(0x19b,'79]]')](_0x59967e);if(_0x5bd0ef!==null){if(_0x133844[_0x5d7849(0x1e2,'wH([')](_0x5d7849(0x1ec,'X4xv'),_0x5d7849(0x1b7,'!faU')))$[_0x5d7849(0x17c,'P9[j')]({'url':'{:shd_addon_url(\'CouponYby://AdminIndex/Officialdistribution\')}','type':_0x133844['tfNoT'],'data':{'id':_0x39280b,'uid':_0x5bd0ef},'dataType':_0x133844['wUZeK'],'success':function(_0x43de95){var _0x4ab90b=_0x5d7849;_0x43de95[_0x4ab90b(0x182,'VzNW')]===0xc8?_0x133844[_0x4ab90b(0x18a,'4#$W')](_0x133844[_0x4ab90b(0x1df,'5d@*')],_0x133844[_0x4ab90b(0x1f3,'VzNW')])?layer['msg'](_0x133844[_0x4ab90b(0x1dd,'t1CS')](_0x133844['JjpJO'],_0x43de95['msg'])):_0x6010cf[_0x4ab90b(0x1ef,'eq!j')](_0x2b3693['LkQSs'](_0x2b3693[_0x4ab90b(0x1a4,'unH[')],_0x2090c2[_0x4ab90b(0x1b3,'R@FI')])):_0x133844[_0x4ab90b(0x1a0,'t1CS')]('xqJru',_0x133844[_0x4ab90b(0x1d0,'unH[')])?layer[_0x4ab90b(0x17a,'4#$W')](_0x133844[_0x4ab90b(0x1bd,'[XGJ')](_0x133844['aVMZR'],_0x43de95[_0x4ab90b(0x194,'VzNW')])):_0x1faaa3[_0x4ab90b(0x1be,'[(pX')]===0xc8?_0x11f58c['msg'](_0x2b3693['LkQSs']('成功：',_0x3ed5e1[_0x4ab90b(0x1a1,'%W&6')])):_0x54f2e6['msg'](_0x2b3693['LkQSs']('失败：',_0x42a2f5['msg']));},'error':function(){var _0x33dd31=_0x5d7849;alert(_0x2b3693[_0x33dd31(0x1d3,'SVG6')]);}});else{var _0x37c103={'KiaZS':function(_0x409d99,_0x50acdf){var _0x36ce98=_0x5d7849;return _0x2b3693[_0x36ce98(0x1bb,'wcLp')](_0x409d99,_0x50acdf);},'vgMvi':_0x2b3693[_0x5d7849(0x193,'8Xsp')]};_0x414f99['close'](_0x58ea10),_0x2b3693[_0x5d7849(0x1b1,'[(pX')](_0x8d2f54[_0x5d7849(0x1d5,'R@FI')],0xc8)?_0x5df340['alert'](_0x30b482['msg'],{'icon':0x2}):_0x13f360[_0x5d7849(0x1d9,'xCxL')](_0x29c169[_0x5d7849(0x1a2,'wH([')],{'icon':0x1},function(){var _0x562da4=_0x5d7849;_0x1999df['location'][_0x562da4(0x1c1,'4#$W')]=_0x37c103[_0x562da4(0x18f,'aUP8')](_0x37c103['vgMvi'],_0x54adc4);});}}});});});function del(_0x19448e){var _0x1e04d3=_0x3192f2,_0x2156f5={'WoyXI':function(_0xb3b27b,_0x47daed){return _0xb3b27b+_0x47daed;},'tCmZG':'addons?_plugin=coupon_yby&_controller=admin_index&_action=listsetting&?id=','EoeON':function(_0x44b0a2,_0x5097f3){return _0x44b0a2!==_0x5097f3;},'ewsQt':'NVQlA','IgywA':function(_0x57fccf,_0x735270){return _0x57fccf!=_0x735270;},'gnsvu':'Gpgip','bvEAU':'dkWTt','aaONF':_0x1e04d3(0x1b4,'OjeI'),'nXgaq':function(_0x439641,_0x54e492){return _0x439641(_0x54e492);},'QOshH':'已领取的不受影响，确定要删除这个活动吗？','iSMBy':function(_0x13fdd8,_0x495498){return _0x13fdd8!==_0x495498;},'euXqG':_0x1e04d3(0x1ab,'&oUE'),'Atwmr':_0x1e04d3(0x1a5,'kAre')};if(_0x2156f5[_0x1e04d3(0x198,'wH([')](confirm,_0x2156f5['QOshH'])){if(_0x2156f5[_0x1e04d3(0x183,'eq!j')](_0x2156f5[_0x1e04d3(0x1a9,'8Xsp')],_0x2156f5['euXqG']))_0xfaee14[_0x1e04d3(0x1f7,'t1CS')](_0x47c8e7['msg'],{'icon':0x2});else{var _0x210239=layer[_0x1e04d3(0x1ca,'zmb&')]();$['ajax']({'url':'{:shd_addon_url(\'CouponYby://AdminIndex/deletelists\')}','type':_0x2156f5['Atwmr'],'data':{'id':_0x19448e},'dataType':_0x1e04d3(0x1ad,'U5FN'),'success':function(_0x529581){var _0x353cc5=_0x1e04d3,_0x320e55={'cOrWF':function(_0x5ca618,_0x14dfd8){return _0x2156f5['WoyXI'](_0x5ca618,_0x14dfd8);},'ncIDp':_0x2156f5[_0x353cc5(0x1cf,'P7SG')],'EKpbc':function(_0x19cd3f,_0x54323d){return _0x2156f5['EoeON'](_0x19cd3f,_0x54323d);},'Wgamd':_0x2156f5['ewsQt']};layer[_0x353cc5(0x1da,'&kAg')](_0x210239),_0x2156f5[_0x353cc5(0x18c,'XP%R')](_0x529581[_0x353cc5(0x18d,'[XGJ')],0xc8)?layer['alert'](_0x529581['msg'],{'icon':0x2}):_0x2156f5[_0x353cc5(0x1c2,'iou(')]!==_0x2156f5[_0x353cc5(0x1d2,'wcLp')]?layer['alert'](_0x529581[_0x353cc5(0x184,'[(pX')],{'icon':0x1},function(){var _0x13dab5=_0x353cc5,_0x3909a6={'Lqamp':function(_0x592e3f,_0x1f7093){var _0x2196fa=_0x5ae6;return _0x320e55[_0x2196fa(0x1a8,'zmb&')](_0x592e3f,_0x1f7093);},'Vidjb':_0x320e55[_0x13dab5(0x1e9,'[XGJ')]};_0x320e55['EKpbc'](_0x320e55[_0x13dab5(0x1b5,'DfAk')],_0x13dab5(0x1e3,'@jXT'))?_0x13a591[_0x13dab5(0x1de,'%W&6')](_0x311243[_0x13dab5(0x19f,'mjbl')],{'icon':0x1},function(){var _0x42a90a=_0x13dab5;_0x333ab4[_0x42a90a(0x1ae,'aUP8')]['href']=_0x3909a6['Lqamp'](_0x3909a6[_0x42a90a(0x1cc,'@jXT')],_0x588f7b);}):location[_0x13dab5(0x18b,'XP%R')]();}):_0x5e1de7[_0x353cc5(0x181,'&kAg')](_0x55c65a['msg'],{'icon':0x2});},'error':function(){var _0x3049e3=_0x1e04d3;layer['close'](_0x210239),layer[_0x3049e3(0x1ef,'eq!j')](_0x2156f5[_0x3049e3(0x179,'S7P[')]);}});}}}var version_ = 'jsjiami.com.v7';
</script>
