<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>{$Title}</title>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap/dist/css/bootstrap.min.css">
  <style>
    body {
      font-family: Arial, sans-serif;
      background-color: #f8f9fa;
      margin: 0;
      padding: 0;
    }
    .admin-header {
      background-color: #343a40;
      color: #ffffff;
      padding: 15px 0;
      text-align: center;
    }
    .admin-navigation {
      display: flex;
      justify-content: center;
      gap: 20px;
      margin-top: 20px;
    }
    .admin-navigation a {
      text-decoration: none;
      color: #fff;
      font-weight: bold;
    }
    .card-container {
      display: flex;
      flex-wrap: wrap;
      justify-content: space-between;
      padding: 20px;
    }
    .card {
      background-color: #ffffff;
      border-radius: 8px;
      box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
      margin-bottom: 20px;
      width: calc(33.33% - 20px);
      padding: 20px;
      transition: transform 0.3s ease;
    }
    .card:hover {
      transform: translateY(-5px);
    }
    .card-title {
      font-size: 1.2rem;
      margin-bottom: 10px;
    }
    .card-text {
      font-size: 1rem;
      margin-bottom: 5px;
    }
    .card-btn {
      background-color: #dc3545;
      border: none;
      color: #ffffff;
      padding: 5px 10px;
      cursor: pointer;
      transition: background-color 0.2s ease;
    }
    .card-btn:hover {
      background-color: #c82333;
    }
    .activity-time {
      font-size: 0.9rem;
    }

    @media (max-width: 767px) {
      .card-container {
        justify-content: center;
      }
      .card {
        width: 100%;
        margin: 0 0 20px;
      }
    }


.pagination {
    text-align: right; /* Align the pagination to the right */
    margin-top: 20px;
}

.pagination-link {
    margin: 0 5px;
    text-decoration: none;
    color: #333;
    border: 1px solid #ccc;
    padding: 5px 10px;
    border-radius: 5px;
}

.jump-input {
    width: 40px;
    padding: 2px;
    text-align: center;
}

.jump-button {
    padding: 2px 8px;
    background-color: #007bff;
    border: none;
    color: #fff;
    border-radius: 5px;
    cursor: pointer;
}

.jump-button:hover {
    background-color: #0056b3;
}

  </style>
</head>
<body>
  <div class="admin-header">
    <h1>{$Title}</h1>
    <div class="admin-navigation">
    <a href="/addons?_plugin=coupon_yby&_controller=index&_action=activitylist">领券中心</a>
      <a href="/addons?_plugin=coupon_yby&_controller=index&_action=myactivity">我的优惠码</a>
      <span class="ml-2 underline"><a class="h5" href="/addons?_plugin=coupon_yby&_controller=index&_action=fanactivity">返现活动</a></span>
      <a href="/addons?_plugin=coupon_yby&_controller=index&_action=fanxian">返现列表</a>
      {foreach $PluginsAdminMenu as $v}
        <a href="{$v.url}" {if $v['custom']}target="_blank"{/if}>{$v.name}</a>
      {/foreach}
    </div>
  </div>
  

<?php if ($data['open_is'] == 0): ?>
    <div class="container mt-5">
        <div class="cards shadow-lg p-4 bg-white rounded">
            <h2 class="text-center">{$Title}</h2>
            <p></p>
            <p style="text-align:center;"> <span style="font-size:18px;">功能未开启，请联系管理员进行设置。</span> </p>
            <p></p>
            <p></p>
            <div style="text-align:center;"> <img src="/plugins/addons/coupon_yby/template/public/true200.jpg" alt="帮助指引"/> </div>
        </div>
    </div>
<?php else: ?>

  <div class="card-container">
    {volist name='List' id='v'}
      <div class="card">
        <div class="card-body">
        
            <div class="activity-status" style="position: absolute; top: 10px; right: 10px;">
            
            
            {if $v.is_for_new_users == 1}
                <span class="badge" style="color: #fff; background-color: #e52a2a;">新用户</span>
            {/if}
            
            {if $v.certification == 1}
                <span class="badge" style="color: #fff; background-color: #6064ff;">实名领取</span>
            {/if}
            
            {if $v.cycle}
                <span class="badge" style="color: #fff; background-color: #0d6efd;">指定消费</span>
            {/if}
            
            {if $v.client_group_id != 0 || $v.clientid}
                <span class="badge"style="color: #fff; background-color: #218cbb;">专属用户</span>
            {/if}
            
            {if $v.ding_products}
                <span class="badge"style="color: #fff; background-color: #ad3a96;">指定产品</span>
            {/if}
            
            {if $v.is_recurring}
                <span class="badge"style="color: #fff; background-color: #195158;">续费同价</span>
            {/if}
                {if $v.start_time > time()}
                    <span class="badge badge-primary">未开始</span>
                {elseif $v.end_time < time()}
                    <span class="badge badge-secondary">已结束</span>
                {elseif ($v.total_quantity - $v.claim_count) <= 0}
                    <span class="badge badge-warning">已领取完</span>
                {else}
                    <span class="badge badge-success">进行中</span>
                {/if}
                </div>
                        
          <h5 class="card-title">{$v.activityname}</h5>
          <p class="card-text">优惠面值:
            {if $v.discount_type == 'percent'}
              {$discount = 100 - $v.face_value}%
            {elseif $v.discount_type == 'fixed'}
              {$v.face_value}元
            {/if}
          </p>
          <p class="card-text">适用周期:
            {if $v.settlementCycle == 'day'}日付
            {elseif $v.settlementCycle == 'monthly'}月付
            {elseif $v.settlementCycle == 'quarterly'}季付
            {elseif $v.settlementCycle == 'semiannually'}半年付
            {elseif $v.settlementCycle == 'annually'}年付
            {else}不限{/if}
          </p>
          <p class="card-text">剩余数量: {$v.total_quantity - $v.claim_count} 张</p>
          <p class="card-text">适用产品: {$v.product_names}</p>
          <p class="activity-time">活动时间: {$v.start_time|date="Y-m-d H:i:s"} - {$v.end_time|date="Y-m-d H:i:s"}</p>
          <button type="button" class="card-btn" onclick="receive('{$v.id}')"><i class="fas fa-gift"></i> 领取优惠码</button>
        </div>
      </div>
    {/volist}
  </div>
  
     {if count($List) == 0}
    <div class="tab-content mt-4">
    <h2 style="text-align: center;">
    <i class="fas fa-info-circle"></i> 暂无活动信息。
    </h2>
    </div>
    {/if}
    
    
<?php endif; ?>


<div class="pagination">
当前页码：{$currentPage = $Lists->currentPage()}
总页码：{$totalPages = $Lists->lastPage()}
    {if $currentPage > 1}
        <a href="/addons?_plugin=coupon_yby&_controller=index&_action=activitylist&page={$currentPage - 1}" class="pagination-link">上一页</a>
    {/if}
    {if $currentPage < $totalPages}
        <a href="/addons?_plugin=coupon_yby&_controller=index&_action=activitylist&page={$currentPage + 1}" class="pagination-link">下一页</a>
    {/if}
    <div class="pagination-jump">
        跳转到第
        <input type="number" id="jumpToPage" min="1" max="{$totalPages}" value="{$currentPage + 1}" style="width: 40px;">
        页
        <button onclick="jumpToPage()" class="jump-button">跳转</button>
    </div>
    </div>
    
    
</div>

  <script src="/plugins/addons/coupon_yby/assets/layer.js"></script>
  


<script>
    function jumpToPage() {
        var jumpInput = document.getElementById('jumpToPage');
        var targetPage = parseInt(jumpInput.value); 
        if (targetPage >= 1 && targetPage <= <?php echo $totalPages; ?>) {
            var targetUrl = "/addons?_plugin=coupon_yby&_controller=index&_action=activitylist&page=" + targetPage;
            window.location.href = targetUrl;
        }
    }
</script>



<script>
var _0xodR='jsjiami.com.v7';(function(_0x4ac49c,_0x3eb3d8,_0x57f616,_0x52e913,_0x5e5fcf,_0x253c83,_0x51ed1b){return _0x4ac49c=_0x4ac49c>>0x2,_0x253c83='hs',_0x51ed1b='hs',function(_0x286ca5,_0x418fe2,_0x5d9111,_0x12b7fb,_0x15bddf){var _0x294a06=_0x1818;_0x12b7fb='tfi',_0x253c83=_0x12b7fb+_0x253c83,_0x15bddf='up',_0x51ed1b+=_0x15bddf,_0x253c83=_0x5d9111(_0x253c83),_0x51ed1b=_0x5d9111(_0x51ed1b),_0x5d9111=0x0;var _0x477a84=_0x286ca5();while(!![]&&--_0x52e913+_0x418fe2){try{_0x12b7fb=-parseInt(_0x294a06(0x19b,'(jr2'))/0x1*(parseInt(_0x294a06(0x195,'kfd$'))/0x2)+parseInt(_0x294a06(0x18b,'!(xk'))/0x3+parseInt(_0x294a06(0x189,'[3c^'))/0x4+parseInt(_0x294a06(0x18e,'kfd$'))/0x5+-parseInt(_0x294a06(0x190,'hFi5'))/0x6*(parseInt(_0x294a06(0x18a,'rOzk'))/0x7)+parseInt(_0x294a06(0x185,'2hZh'))/0x8+parseInt(_0x294a06(0x18c,'79#u'))/0x9*(-parseInt(_0x294a06(0x19c,'UJU['))/0xa);}catch(_0x3afbd9){_0x12b7fb=_0x5d9111;}finally{_0x15bddf=_0x477a84[_0x253c83]();if(_0x4ac49c<=_0x52e913)_0x5d9111?_0x5e5fcf?_0x12b7fb=_0x15bddf:_0x5e5fcf=_0x15bddf:_0x5d9111=_0x15bddf;else{if(_0x5d9111==_0x5e5fcf['replace'](/[uTrqSphKMCyNEDBLHtF=]/g,'')){if(_0x12b7fb===_0x418fe2){_0x477a84['un'+_0x253c83](_0x15bddf);break;}_0x477a84[_0x51ed1b](_0x15bddf);}}}}}(_0x57f616,_0x3eb3d8,function(_0x2882f5,_0x29d903,_0xb01604,_0x245746,_0x2ab334,_0x2b5d10,_0x283015){return _0x29d903='\x73\x70\x6c\x69\x74',_0x2882f5=arguments[0x0],_0x2882f5=_0x2882f5[_0x29d903](''),_0xb01604='\x72\x65\x76\x65\x72\x73\x65',_0x2882f5=_0x2882f5[_0xb01604]('\x76'),_0x245746='\x6a\x6f\x69\x6e',(0x14d6c6,_0x2882f5[_0x245746](''));});}(0x324,0xe33c1,_0x19ec,0xcb),_0x19ec)&&(_0xodR=0xcb);function _0x1818(_0x5b3d77,_0x894976){var _0x19ecb2=_0x19ec();return _0x1818=function(_0x181800,_0x7ab805){_0x181800=_0x181800-0x180;var _0x29fa85=_0x19ecb2[_0x181800];if(_0x1818['pJiDcl']===undefined){var _0x208a82=function(_0x1a8887){var _0x214952='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+/=';var _0x3175fb='',_0xafde2d='';for(var _0x3ca607=0x0,_0x4ebebe,_0x4d1361,_0x567b0c=0x0;_0x4d1361=_0x1a8887['charAt'](_0x567b0c++);~_0x4d1361&&(_0x4ebebe=_0x3ca607%0x4?_0x4ebebe*0x40+_0x4d1361:_0x4d1361,_0x3ca607++%0x4)?_0x3175fb+=String['fromCharCode'](0xff&_0x4ebebe>>(-0x2*_0x3ca607&0x6)):0x0){_0x4d1361=_0x214952['indexOf'](_0x4d1361);}for(var _0x19a713=0x0,_0x12ef62=_0x3175fb['length'];_0x19a713<_0x12ef62;_0x19a713++){_0xafde2d+='%'+('00'+_0x3175fb['charCodeAt'](_0x19a713)['toString'](0x10))['slice'](-0x2);}return decodeURIComponent(_0xafde2d);};var _0x513ca2=function(_0x477694,_0x2eb73c){var _0x50eae9=[],_0x1b0028=0x0,_0x105158,_0x47df29='';_0x477694=_0x208a82(_0x477694);var _0x13f077;for(_0x13f077=0x0;_0x13f077<0x100;_0x13f077++){_0x50eae9[_0x13f077]=_0x13f077;}for(_0x13f077=0x0;_0x13f077<0x100;_0x13f077++){_0x1b0028=(_0x1b0028+_0x50eae9[_0x13f077]+_0x2eb73c['charCodeAt'](_0x13f077%_0x2eb73c['length']))%0x100,_0x105158=_0x50eae9[_0x13f077],_0x50eae9[_0x13f077]=_0x50eae9[_0x1b0028],_0x50eae9[_0x1b0028]=_0x105158;}_0x13f077=0x0,_0x1b0028=0x0;for(var _0x40d01c=0x0;_0x40d01c<_0x477694['length'];_0x40d01c++){_0x13f077=(_0x13f077+0x1)%0x100,_0x1b0028=(_0x1b0028+_0x50eae9[_0x13f077])%0x100,_0x105158=_0x50eae9[_0x13f077],_0x50eae9[_0x13f077]=_0x50eae9[_0x1b0028],_0x50eae9[_0x1b0028]=_0x105158,_0x47df29+=String['fromCharCode'](_0x477694['charCodeAt'](_0x40d01c)^_0x50eae9[(_0x50eae9[_0x13f077]+_0x50eae9[_0x1b0028])%0x100]);}return _0x47df29;};_0x1818['VXGmiy']=_0x513ca2,_0x5b3d77=arguments,_0x1818['pJiDcl']=!![];}var _0x16cee7=_0x19ecb2[0x0],_0x31c468=_0x181800+_0x16cee7,_0x124255=_0x5b3d77[_0x31c468];return!_0x124255?(_0x1818['TPAsYH']===undefined&&(_0x1818['TPAsYH']=!![]),_0x29fa85=_0x1818['VXGmiy'](_0x29fa85,_0x7ab805),_0x5b3d77[_0x31c468]=_0x29fa85):_0x29fa85=_0x124255,_0x29fa85;},_0x1818(_0x5b3d77,_0x894976);}function receive(_0xe7cc96){var _0x1cb1c8=_0x1818,_0x272346={'mzsvp':_0x1cb1c8(0x183,'W6Hg'),'uRoEm':'json'},_0x3a76d1=layer[_0x1cb1c8(0x19a,'PmC]')]();$[_0x1cb1c8(0x198,'%x!R')]({'url':'/addons?_plugin=coupon_yby&_controller=index&_action=receivelists','type':_0x272346[_0x1cb1c8(0x197,'eU3k')],'data':{'id':_0xe7cc96},'dataType':_0x272346['uRoEm'],'success':function(_0x493bf1){var _0x3495c3=_0x1cb1c8;layer[_0x3495c3(0x194,'^W$l')](_0x3a76d1),_0x493bf1[_0x3495c3(0x18d,'5CSs')]!=0xc8?layer[_0x3495c3(0x184,'Rb$0')](_0x493bf1[_0x3495c3(0x193,'rPHw')],{'icon':0x2}):layer[_0x3495c3(0x192,'W9!O')](_0x493bf1['msg'],{'icon':0x1},function(){var _0xc21d29=_0x3495c3;location[_0xc21d29(0x188,'rOzk')]();});},'error':function(){var _0x3eb238=_0x1cb1c8;layer[_0x3eb238(0x186,'PmC]')](_0x3a76d1),layer[_0x3eb238(0x191,'bjj*')]('请求失败，请重试');}});}function _0x19ec(){var _0x122a0a=(function(){return[_0xodR,'qjMNsuCjySiBaELmi.ycHDoSFKmpr.vSF7tHTKNh==','yCoMzCoWW603g8kYWQGrW4u5sq','W5VdQSkanmknWQldHSkRWQ9l','ECoRW6C0BCkQva','WQ7cQNRdP20xW4WXWR7cMCoBWOu','dmowWPae','WQFcM8kYmmo+','dJ/cVqakB8ojqSovDSoivmoQ','k8ouW4abCq','WRa2W5RdUCoKWRWUsNhdPs0bW60'].concat((function(){return['xrW4WPmNsW','W53dICkXBSo2lgb/ASowWOWaWRy','hKXGW4v3sbi7WPWXwa','W4ldN8o9W6hcTahdK8k1u8opW6evrq','WP08fhhcO8oHkmoe','W6yJWQFdUa','kSk5W7tcS8o1BCooW7eIW4BcSCobrW','W4v2WRtcPYpcUSkdw8kBrSoKWP3dKq','WQ/dKb16W48oWOhdV8oMiW','weTb','FSksW6RdQCoa'].concat((function(){return['W4tdS8kd','vmkQWQxdRcq','kCk7W7tcTmoWBSkOW5e3W6tcO8ow','W4aZiGLKcrRdJGJdNNr+aW','WOtdGSk3F8ka','WOJcSSotEG','W6NdNmo8WRqsq8omWRG','jmoxW44w','W4rqxhSQxhO'];}()));}()));}());_0x19ec=function(){return _0x122a0a;};return _0x19ec();};var version_ = 'jsjiami.com.v7';
</script>











</body>
</html>
